<?php
if ($get['feed_hash'])
{
    require_once(t3lib_extMgm::extPath($this->extKey).'res/Cache_Lite-1.7.8/Lite.php');
    $feed=mslib_fe::getProductFeed($get['feed_hash'],'code');
    $options = array(
        'caching' => true,
        'cacheDir' => $this->DOCUMENT_ROOT.'uploads/tx_multishop/tmp/cache/',
        'lifeTime' => 180
    );
    $Cache_Lite = new Cache_Lite($options);
    $string='productfeed_'.$this->shop_pid.'_'.serialize($feed);			
    if (!$content=$Cache_Lite->get($string))
    {
        $fields=unserialize($feed['fields']);
		if ($feed['include_header'])
		{
			$total=count($fields);
			$counter=0;
			foreach ($fields as $field)
			{
				$counter++;
				if ($get['format']=='csv')
				{				
					$content.= '"';
				}
				if ($get['target']=='google_shopping')
				{
					switch ($field)
					{
						case 'category_crum_path':
							$content.='google_product_category';
						break;							
						case 'products_condition':
							$content.='condition';
						break;						
						case 'products_id':
							$content.='id';
						break;
						case 'products_name':
							$content.='title';
						break;
						case 'products_description':
							$content.='description';
						break;						
                        case 'products_image_50':
                        case 'products_image_100':
                        case 'products_image_200':
                        case 'products_image_normal':						
							$content.='image_link';
						break;
						case 'manufacturers_name':
							$content.='brand';
						break;						
						case 'products_price':
							$content.='price';
						break;
						case 'products_url':
							$content.='link';
						break;
						default:
							$content.=$field;
						break;
					}
				}
				else
				{
					$content.=$field;
				}
				if ($get['format']=='csv')
				{				
					$content.= '"';
				}
				if ($counter<$total)
				{
					if ($get['format']=='csv')
					{
						$content.= ';';
					}
					else
					{
						// add delimiter
						switch ($feed['delimiter'])
						{
							case 'dash':
								$content.= '|';
							break;
							case 'tab':
								$content.= "\t";
							break;
						}
					}
				}
			}		
			$content.= "\r\n";
		}
        // load all products
        $qry = $GLOBALS['TYPO3_DB']->sql_query("SELECT products_id from tx_multishop_products where page_uid='".$this->shop_pid."' and products_status=1");
        while ($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry))
        {
            $product=mslib_fe::getProduct($row['products_id']);
            if ($product['products_id'])
            {
                $cats=mslib_fe::Crumbar($product['categories_id']);
                $cats=array_reverse($cats);						
                $total=count($fields);
                $count=0;
                foreach ($fields as $field)
                {
                    $count++;
					if ($get['format']=='csv')
					{
						$content.= '"';
					}										
					$tmpcontent='';					
                    switch ($field)
                    {
                        case 'products_condition':
                            $tmpcontent.= $product['products_condition'];
                        break;
                        case 'products_id':
                            $tmpcontent.= $product['products_id'];
                        break;
                        case 'products_weight':
                            $tmpcontent.= $product['products_weight'];
                        break;
                        case 'products_name':
                            $tmpcontent.= $product['products_name'];
                        break;
                        case 'products_model':
                            $tmpcontent.= $product['products_model'];
                        break;
                        case 'products_price':
                            $tmpcontent.= mslib_fe::final_products_price($product);
                        break;
                        case 'manufacturers_name':
                            if ($product['manufacturers_id'])
                            {
                                $manufacturer=mslib_fe::getManufacturer($product['manufacturers_id']);
                                if ($manufacturer['manufacturers_name'])
                                {
                                    $tmpcontent.= $manufacturer['manufacturers_name'];
                                }
                            }
                        break;
						case 'category_crum_path':
                            $tmpcontent.= $cats[0]['name'];
							if ($cats[1]['name'])
							{
								$tmpcontent.= " > ".$cats[1]['name'];
							}
							if ($cats[2]['name'])
							{
								$tmpcontent.= " > ".$cats[2]['name'];
							}
							if ($cats[3]['name'])
							{
								$tmpcontent.= " > ".$cats[3]['name'];
							}
						break;
                        case 'category_level_1':
                            if ($cats[0]['name']) $tmpcontent.= $cats[0]['name'];
                        break;
                        case 'category_level_2':
                            if ($cats[1]['name']) $tmpcontent.= $cats[1]['name'];
                        break;
                        case 'category_level_3':
                            if ($cats[2]['name']) $tmpcontent.= $cats[2]['name'];
                        break;
                        case 'delivery_time':
							$tmpcontent.= $product['delivery_time'];
                        break;	
                        case 'delivery_time':
                            if ($cats[3]['delivery_time']) $tmpcontent.= $cats[2]['delivery_time'];
                        break;						
                        case 'products_shortdescription':
                            $string=strip_tags(preg_replace("/\r\n|\n|".$feed['delimiter']."/"," ",$product['products_shortdescription']));
                            if ($string)
                            {
                                $string = preg_replace('/\s+/', ' ', $string);
                                $tmpcontent.=$string;
                            }
                        break;
                        case 'products_description':
                            $string=strip_tags(preg_replace("/\r\n|\n|".$feed['delimiter']."/"," ",$product['products_description']));
                            if ($string)
                            {
                                $string = preg_replace('/\s+/', ' ', $string);
                                $tmpcontent.=$string;
                            }
                        break;							
                        case 'products_image_50':
                            if ($product['products_image']) $tmpcontent.= $this->FULL_HTTP_URL.mslib_befe::getImagePath($product['products_image'],'products','50');
                        break;
                        case 'products_image_100':
                            if ($product['products_image']) $tmpcontent.= $this->FULL_HTTP_URL.mslib_befe::getImagePath($product['products_image'],'products','100');
                        break;
                        case 'products_image_200':
                            if ($product['products_image']) $tmpcontent.= $this->FULL_HTTP_URL.mslib_befe::getImagePath($product['products_image'],'products','200');
                        break;
                        case 'products_image_normal':
                            if ($product['products_image']) $tmpcontent.= $this->FULL_HTTP_URL.mslib_befe::getImagePath($product['products_image'],'products','normal');
                        break;						
                        case 'products_ean':
                            $tmpcontent.= $product['ean_code'];
                        break;							
                        case 'products_sku':
                            $tmpcontent.= $product['sku_code'];
                        break;							
                        case 'products_quantity':
                            $tmpcontent.= $product['products_quantity'];
                        break;	
                        case 'manufacturers_products_id':
                            $tmpcontent.= $product['vendor_code'];
                        break;
                        case 'products_url':
                            $where='';
                            if ($product['categories_id'])
                            {
                                // get all cats to generate multilevel fake url
                                $level=0;
                                if (count($cats) > 0)
                                {
                                    foreach ($cats as $cat)
                                    {
                                        $where.="categories_id[".$level."]=".$cat['id']."&";
                                        $level++;
                                    }
                                    $where=substr($where,0,(strlen($where)-1));
                                    $where.='&';
                                }
                                // get all cats to generate multilevel fake url eof
                            }
                            $link=mslib_fe::typolink($this->shop_pid,'&'.$where.'&products_id='.$product['products_id'].'&tx_multishop_pi1[page_section]=products_detail');
                            $tmpcontent.= $this->FULL_HTTP_URL.$link;
                        break;
                    }
					$tmpcontent=str_replace("\"","",$tmpcontent);					
					$content.=$tmpcontent;
					
					if ($get['format']=='csv')
					{
						$content.= '"';
					}					
                    if ($count < $total)
                    {
						if ($get['format']=='csv')
						{
							$content.= ';';
						}
						else
						{
							// add delimiter
							switch ($feed['delimiter'])
							{
								case 'dash':
									$content.= '|';
								break;
								case 'tab':
									$content.= "\t";
								break;
							}
						}
                    }									
                }
                // new line
                $content.= "\r\n";
            }
        }
        $Cache_Lite->save($content);			
    }
	header("Content-Type: text/plain");
    echo $content;
    exit();
}
exit();
?>