<?php
$cart = $GLOBALS['TSFE']->fe_user->getKey('ses',$this->cart_page_uid);
if ($ms['MODULES']['DISABLE_VAT_RATE_WHEN_CROSS_BORDERS'])
{
	// if store country is different than customer country change VAT rate to zero
	if ($cart['user']['country'])
	{
		$iso_customer=mslib_fe::getCountryByName($cart['user']['country']);
		if ($iso_customer['cn_iso_nr'] != $ms['MODULES']['COUNTRY_ISO_NR'])
		{
			$ms['MODULES']['DISABLE_VAT_RATE']=1;
		}
	}
	// if store country is different than customer country change VAT rate to zero eof
}
if (count($cart['products']) < 1)
{
	$content.='<div class="noitems_message">'.$this->pi_getLL('there_are_no_products_in_your_cart').'</div>';
}
else
{
	if ($posted_page==current($stepCodes))
	{
		if (!$post['accept_general_conditions'])
		{
			$erno[]=$this->pi_getLL('you_havent_accepted_the_general_conditions').'.';
		}
		if (!count($erno))
		{
			// good, proceed with the next step
		//	next($stepCodes);
		//	include(current($stepCodes).'.php');	
			include('checkout_process.php');	
		}
	}
	else
	{
		$show_review=1;
	}	
	if ($erno or $show_review)
	{
		$content.=CheckoutStepping($stepCodes,current($stepCodes),$this);	
		$back_button_link=mslib_fe::typolink($this->conf['checkout_page_pid'],'&tx_multishop_pi1[page_section]='.$ms['page'].'&tx_multishop_pi1[previous_checkout_section]='.prev($stepCodes));
		next($stepCodes);
		$products = $cart['products'];
		$user = $cart['user'];
		if (count($products) < 1)
		{
			$content.='<div class="noitems_message">'.$this->pi_getLL('there_are_no_products_in_your_cart').'</div>';
		}
		else
		{
			if (is_array($erno) and count($erno) > 0)
			{
				$content.='<div class="error_msg">';
				$content.=$this->pi_getLL('the_following_errors_occurred').': <ul>';
				foreach ($erno as $item)
				{
					$content.='<li>'.$item.'</li>';
				}
				$content.='</ul>';
				$content.='</div>';
			}				
			$colspan=5;
			$content.='
			<div class="main-heading"><h2>'.$this->pi_getLL('review_your_order').'</h2></div>
			<div class="content">
			<form action="'.mslib_fe::typolink($this->conf['checkout_page_pid'],'&tx_multishop_pi1[page_section]='.$ms['page'].'&tx_multishop_pi1[previous_checkout_section]='.current($stepCodes)).'" method="post" name="checkout" id="checkout">';
			$content.='<table width="100%" border="0" align="center"   class="border" id="shoppingcart_listing">';
			$content.='<tr><th class="checkout_products_image">&nbsp;</th><th class="checkout_products_qty">'.$this->pi_getLL('qty').'</th><th class="checkout_products_name">'.$this->pi_getLL('products_name').'</th><th class="checkout_products_vat">'.$this->pi_getLL('vat').'</th>';
			if ($ms['MODULES']['SHOW_PRICES_INCLUDING_VAT'])
			{
				$content.='<th nowrap class="checkout_products_price_vat">'.$this->pi_getLL('price_including_vat').'</th>';
			}
			else
			{
				$content.='<th nowrap class="checkout_products_price_vat">'.$this->pi_getLL('price_excluding_vat').'</th>';
			}
			$content.='</tr>';
			$subtotal=0;
			$subtotal_tax=0;
			foreach ($products as $shopping_cart_item => $value)
			{
				// if store country is different than customer country change VAT rate to zero
				if ($ms['MODULES']['DISABLE_VAT_RATE']) $value['tax_rate']=0.00;
				$products_id=$value['products_id'];
				$subprices='';
				if (is_numeric($products_id))
				{		
					if (!$value['products_image']) 	$image	='<div class="no_image_50"></div>';
					else
					{
						if (!strstr(strtolower($value['products_image']),'http://') and !strstr(strtolower($value['products_image']),'https://'))
						{
							$value['products_image']=mslib_befe::getImagePath($value['products_image'],'products','50');
						}
						$image	='<img src="'.$value['products_image'].'">';			
					}
					if (!$tr_type or $tr_type=='even') 	$tr_type='odd';
					else								$tr_type='even';					
					$price=round(($value['qty']*$value['final_price']),4);
					$final_price=($value['qty']*$value['final_price']);				
					$content.='<tr class="'.$tr_type.'">
						<td class="checkout_listing_image_td"><div class="checkout_listing_image">'.$image.'</div></td>
						<td class="checkout_listing_qty">'.$value['qty'].'</td>				
						<td class="checkout_listing_name"><span class="bold">'.$value['products_name'].($value['products_model']?' <span class="checkout_listing_products_model">('.$value['products_model'].')</span>':'').'</span>';
					if (is_array($value['attributes']))
					{
						// loading the attributes
						foreach ($value['attributes'] as $attribute_key => $attribute_values)
						{
							$continue=0;
							if (is_numeric($attribute_key))
							{
								$str="SELECT products_options_name,listtype from tx_multishop_products_options o where o.products_options_id='".$attribute_key."' ";
								$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
								$row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry);
							}					
							switch ($row['listtype'])
							{
								case 'checkbox':
									$content.='<br />'.$row['products_options_name'].': ';
									$continue=0;
									$total=count($attribute_values);
									$counter=0;
									foreach ($attribute_values as $item)
									{
										$counter++;
										$final_subprice=0;	
										$price=$price+($value['qty']*($item['price_prefix'].$item['options_values_price']));
										$final_subprice=($value['qty']*($item['price_prefix'].$item['options_values_price']));	
										if ($value['tax_rate'] and $ms['MODULES']['SHOW_PRICES_INCLUDING_VAT'])
										{
											$final_subprice=round(($final_subprice*($value['tax_rate'])),4)+$final_subprice;
										}									
										$content.=trim($item['products_options_values_name']);
										if ($item['options_values_price'] >0) $subprices.=mslib_fe::Money2Cents($final_subprice);							
										$subprices.='<br />';
										if ($counter < $total) $content.=', ';
									}							
								break;
								case 'input':
									$content.='<br />'.$row['products_options_name'].': '.$value['attributes'][$attribute_key]['products_options_values_name'];
									$multiple=0;
									$continue=0;
								break;
								default:
									$multiple=0;
									$continue=1;
								break;
							}
							if ($continue)
							{
								$array=array($attribute_values);
								foreach ($array as $item)
								{
									$content.='<br />'.$item['products_options_name'].': '.$item['products_options_values_name'].$t;
									$final_subprice=0;	
									$price=$price+($value['qty']*($item['price_prefix'].$item['options_values_price']));
									$final_subprice=($value['qty']*($item['price_prefix'].$item['options_values_price']));	
									if ($value['tax_rate'] and $ms['MODULES']['SHOW_PRICES_INCLUDING_VAT'])
									{
										$final_subprice=round(($final_subprice*($value['tax_rate'])),4)+$final_subprice;
									}
									if ($item['options_values_price'] >0) $subprices.=mslib_fe::Money2Cents($final_subprice);							
									$subprices.='<br />';
								}
							}								
						}
						// loading the attributes eof				
					}
					if ($ms['MODULES']['SHOW_PRICES_INCLUDING_VAT'])
					{
						$final_price=round(($final_price*($value['tax_rate'])),4)+$final_price;
					}					
					if ($subprices)
					{
						$subprices='<div class="attribute_prices">'.$subprices.'</div>';
					}					
					$content.='	
						</td>
						<td class="checkout_listing_vat">'.(($value['tax_rate'])?($value['tax_rate']*100).'%':'&nbsp;').'</td>
						<td class="checkout_listing_price">'.mslib_fe::Money2Cents($final_price).$subprices.'</td>
					</tr>';
					$subprices='';
					$subtotal=($subtotal+$price);
					if ($value['tax_rate'])	$tax=round(($price*($value['tax_rate'])),4);
					else					$tax=0;
					$subtotal_tax=($subtotal_tax+$tax);				
				}
			}
			$footer_subtotal.='<table border="0" cellspacing="0"  align="right">';
			$footer_subtotal.='<tr><td class="label"><strong>'.$this->pi_getLL('subtotal').'</strong></td><td class="values" align="right">'.mslib_fe::Money2Cents($subtotal).'</td></tr>';
			if ($ms['MODULES']['INCLUDE_VAT_OVER_METHOD_COSTS'])
			{
				if ($user['shipping_method_costs'])	$footer_subtotal.='<tr><td class="label">'.$this->pi_getLL('shipping_costs').' ('.$user['shipping_method_label'].')</td><td class="values" align="right">'.mslib_fe::Money2Cents($user['shipping_method_costs']).'</td></tr>';
				if ($user['payment_method_costs'])	$footer_subtotal.='<tr><td class="label">'.$this->pi_getLL('payment_costs').' ('.$user['payment_method_label'].')</td><td class="values" align="right">'.mslib_fe::Money2Cents($user['payment_method_costs']).'</td></tr>';
				$subtotal_tax=$subtotal_tax+($user['shipping_method_costs']/100*$ms['MODULES']['INCLUDE_VAT_OVER_METHOD_COSTS']);
				$subtotal_tax=$subtotal_tax+($user['payment_method_costs']/100*$ms['MODULES']['INCLUDE_VAT_OVER_METHOD_COSTS']);
				if ($subtotal_tax)
				{
					$footer_subtotal.='<tr><td class="label">'.$this->pi_getLL('vat').'</td><td class="values" align="right">'.mslib_fe::Money2Cents($subtotal_tax).'</td></tr>';
				}				
			}
			else
			{			
				if ($subtotal_tax)
				{
					$footer_subtotal.='<tr><td class="label">'.$this->pi_getLL('vat').'</td><td class="values" align="right">'.mslib_fe::Money2Cents($subtotal_tax).'</td></tr>';
				}			
				if ($user['shipping_method_costs'])	$footer_subtotal.='<tr><td class="label">'.$this->pi_getLL('shipping_costs').' ('.$user['shipping_method_label'].')</td><td class="values" align="right">'.mslib_fe::Money2Cents($user['shipping_method_costs']).'</td></tr>';
				if ($user['payment_method_costs'])	$footer_subtotal.='<tr><td class="label">'.$this->pi_getLL('payment_costs').' ('.$user['payment_method_label'].')</td><td class="values" align="right">'.mslib_fe::Money2Cents($user['payment_method_costs']).'</td></tr>';
			}
			if (!$GLOBALS["TSFE"]->fe_user->user['uid'] and $cart['user']['email'])
			{
				// check if guest user is already in the database and if so add possible group discount
				$user_check=mslib_fe::getUser($cart['user']['email'],'email');
				if ($user_check['uid'])
				{
					$discount_percentage=mslib_fe::getUserGroupDiscount($user_check['uid']);				
					if ($discount_percentage)
					{
						$cart['coupon_code']	='';
						$cart['discount']		=$discount_percentage;
						$cart['discount_type']	='percentage';
						$GLOBALS['TSFE']->fe_user->setKey('ses',$this->cart_page_uid, $cart);
						$GLOBALS['TSFE']->fe_user->storeSessionData();				
					}
				}
			}			
			if ($cart['discount'])
			{
				$footer_subtotal.='<tr><td class="label">'.$this->pi_getLL('discount').'</td><td class="values" align="right">';
				switch ($cart['discount_type'])
				{
					case 'percentage':
						$footer_subtotal.= number_format($cart['discount']).'%';
						$discount_price=(($subtotal+$subtotal_tax)/100*$cart['discount']);
					break;
					case 'price':
						$footer_subtotal.= mslib_fe::Money2Cents($cart['discount']);
						$discount_price=$cart['discount'];
					break;
				}				
				$footer_subtotal.='</td></tr>';
			}			
			$footer_subtotal.='<tr><td colspan="2" class="values"><hr class="hr"></hr></td></tr>';
			$total=($user['shipping_method_costs']+$user['payment_method_costs']+$subtotal+$subtotal_tax-$discount_price);
			$footer_subtotal.='<tr><td class="label"><h4>'.$this->pi_getLL('total').'</h4></td><td align="right" class="values"><strong>'.mslib_fe::Money2Cents($total).'</strong></td></tr>';
			$footer_subtotal.='</table>';
			
			$content.='<tr id="bottomColumnRight">
				<td colspan="'.$colspan.'">'.$footer_subtotal.'</td>
			</tr>
			<tr id="bottomColumnComments"> 
				<td colspan="'.$colspan.'"> 
					<div class="shoppingcart_description"> 
						<div class="shoppingcart_label"><strong>'.$this->pi_getLL('comments').'</strong></div> 
						<textarea name="customer_comments" id="customer_comments"></textarea> 
					</div> 
				</td> 
			</tr> 			
			';
			$content.='</table>';	
			$content.='
				<hr>
				<div class="accept_general_conditions_container">					
					<input name="accept_general_conditions" id="accept_general_conditions" type="checkbox" value="1" />
					<label for="accept_general_conditions">'.$this->pi_getLL('click_here_if_you_agree_the_general_conditions');
$page=mslib_fe::getCMScontent('general_conditions',$GLOBALS['TSFE']->sys_language_uid);	
if ($page[0]['content'])
{
	$content.=' (<a href="'.mslib_fe::typolink($this->shop_pid,'&tx_multishop_pi1[page_section]=info&tx_multishop_pi1[cms_hash]='.$page[0]['hash']).'" target="_blank" class="read_general_conditions">'.$this->pi_getLL('view_general_conditions').'</a>)';
}
$content.='
				</div>
				<div id="bottom-navigation">
					<a href="'.$back_button_link.'" class="back_button">'.$this->pi_getLL('back').'</a>
					<div class="cart">
					<input name="Submit" type="submit" class="float_right confirm_order_en" value="'.$this->pi_getLL('confirm_order').'" /></div>
				</div>
			</form>	
			</div>
			<script>
			jQuery("#checkout").submit(function(){
				if (!jQuery("#accept_general_conditions").is(":checked")){
					alert(\''.htmlspecialchars(addslashes($this->pi_getLL('you_havent_accepted_the_general_conditions').'.')).'\');
					return false;
				}
			});
			</script>
			';
		}
	}
}
?>